
#include <errno.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

void *threadfunc(void *arg);

pthread_mutex_t mutex;
pthread_cond_t cond;

int main(void)
{
	int x,ret;
	int retval, sharedval;
	pthread_t new;
	struct timespec ts;
	printf("1: condition variable test 6 (pthread_cond_timedwait())\n");

	pthread_mutex_init(&mutex, NULL);
	pthread_cond_init(&cond, NULL);

	pthread_mutex_lock(&mutex);

	sharedval = 1;

	ret = pthread_create(&new, NULL, threadfunc, &sharedval);
	if (ret != 0)
		err(1, "pthread_create");


	printf("1: Before waiting.\n");
	do {
		ts.tv_sec = time(NULL) + 2;
		ts.tv_nsec = 0;
		retval = pthread_cond_timedwait(&cond, &mutex, &ts);
		printf("1: After waiting, in loop. Return value %d\n", retval);

	} while (retval != ETIMEDOUT);

	printf("1: After the loop.\n");

	pthread_mutex_unlock(&mutex);

	printf("1: After releasing the mutex.\n");

	ret = pthread_join(new, NULL);
	if (ret != 0)
		err(1, "pthread_join");

	printf("1: Thread joined.\n");

	return 0;
}


void *threadfunc(void *arg)
{
	int *share = (int *) arg;

	printf("2: Second thread.\n");

       	printf("2: Doing nothing.\n");
	sleep(5);

       	printf("2: Exiting.\n");

	return NULL;
}
